//xmas.c - Xmas mod specific routines

#include "g_local.h"

void Xmas_Level_End_Music(void)
{//Choose a tune to play at level end
	char* Command;
	int Random;

	Random = rand() % 300;

	if (Random < 100)
		Command = "play xmas/endmusic.wav";
	else
	if (Random < 200)
		Command = "play xmas/itsxmastime.wav";
	else
		Command = "play xmas/slade.wav";

//Send the command
	gi.WriteByte(svc_stufftext);
	gi.WriteString(Command);
	gi.multicast(vec3_origin, MULTICAST_ALL);
}

/*QUAKED christmas_snowman_thug (1 .5 0) (-16 -16 -24) (16 16 48)

A Snowman Statue

count 1 = cigar
count 2 = fedora hat
count 4 = steson hat
count 8 = cap (hat)

model="models\actors\thug\head.mdx;models\actors\thug\body.mdx;models\actors\thug\legs.mdx"

skin="models\actors\thug\head_fst.tga;models\actors\thug\body_fst.tga;models\actors\thug\legs_fst.tga"
*/
void SP_christmas_snowman_thug(edict_t *self)
{
	int i;
	char	*head_skin, *body_skin, *legs_skin;
	int	skin;

	self->solid = SOLID_BBOX;
	self->movetype = MOVETYPE_NONE;
	self->svflags |= SVF_PROP;
	VectorSet(self->mins, -16, -16, -24);
	VectorSet(self->maxs, 16, 16, 48);

	// MH: crash fix
	head_skin = body_skin = legs_skin = "sno";

	memset(&(self->s.model_parts[0]), 0, sizeof(model_part_t) * MAX_MODEL_PARTS);
	self->s.num_parts++;
	self->s.model_parts[PART_HEAD].modelindex = gi.modelindex("models/actors/thug/head.mdx");
	skin = gi.skinindex(self->s.model_parts[PART_HEAD].modelindex, head_skin);
	for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
		self->s.model_parts[PART_HEAD].baseskin = self->s.model_parts[PART_HEAD].skinnum[i] = skin;
	gi.GetObjectBounds("models/actors/thug/head.mdx", &self->s.model_parts[PART_HEAD]);

	self->s.num_parts++;
	self->s.model_parts[PART_LEGS].modelindex = gi.modelindex("models/actors/thug/legs.mdx");
	skin = gi.skinindex(self->s.model_parts[PART_LEGS].modelindex, legs_skin);
	for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
		self->s.model_parts[PART_LEGS].baseskin = self->s.model_parts[PART_LEGS].skinnum[i] = skin;
	gi.GetObjectBounds("models/actors/thug/legs.mdx", &self->s.model_parts[PART_LEGS]);

	self->s.num_parts++;
	self->s.model_parts[PART_BODY].modelindex = gi.modelindex("models/actors/thug/body.mdx");
	skin = gi.skinindex(self->s.model_parts[PART_BODY].modelindex, body_skin);
	for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
		self->s.model_parts[PART_BODY].baseskin = self->s.model_parts[PART_BODY].skinnum[i] = skin;
	gi.GetObjectBounds("models/actors/thug/body.mdx", &self->s.model_parts[PART_BODY]);

	if (self->count & 1) // cigar
	{
		self->s.num_parts++;
		self->s.model_parts[PART_CIGAR].modelindex = gi.modelindex("models/actors/thug/cigar.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_CIGAR].baseskin = self->s.model_parts[PART_CIGAR].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/cigar.mdx", &self->s.model_parts[PART_CIGAR]);
	}

	if (self->count & 2) // fedora hat
	{
		self->s.num_parts++;
		self->s.model_parts[PART_HAT].modelindex = gi.modelindex("models/actors/thug/fedora.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_HAT].baseskin = self->s.model_parts[PART_HAT].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/fedora.mdx", &self->s.model_parts[PART_HAT]);
	}
	else if (self->count & 4) // stetson hat
	{
		self->s.num_parts++;
		self->s.model_parts[PART_HAT].modelindex = gi.modelindex("models/actors/thug/stetson.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_HAT].baseskin = self->s.model_parts[PART_HAT].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/stetson.mdx", &self->s.model_parts[PART_HAT]);
	}
	else if (self->count & 8) // cap (hat)
	{
		self->s.num_parts++;
		self->s.model_parts[PART_HAT].modelindex = gi.modelindex("models/actors/thug/cap.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_HAT].baseskin = self->s.model_parts[PART_HAT].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/cap.mdx", &self->s.model_parts[PART_HAT]);
	}


	self->s.renderfx2 |= RF2_DIR_LIGHTS;
	self->s.renderfx |= RF_REFL_MAP;

	self->surfacetype = SURF_GRAVEL;

	gi.linkentity(self);
}

/*QUAKED christmas_snowman_runt (1 .5 0) (-16 -16 -24) (16 16 48)

A Snowman Statue

count 1 = cigar
count 2 = fedora hat
count 4 = steson hat
count 8 = cap (hat)

model="models\actors\runt\head.mdx;models\actors\runt\body.mdx;models\actors\runt\legs.mdx"

skin="models\actors\thug\head_fst.tga;models\actors\thug\body_fst.tga;models\actors\thug\legs_fst.tga"
*/
void SP_christmas_snowman_runt(edict_t *self)
{
	int i;
	char	*head_skin, *body_skin, *legs_skin;
	int	skin;

	self->solid = SOLID_BBOX;
	self->movetype = MOVETYPE_NONE;
	self->svflags |= SVF_PROP;
	VectorSet(self->mins, -16, -16, -24);
	VectorSet(self->maxs, 16, 16, 48);

	// MH: crash fix
	head_skin = body_skin = legs_skin = "sno";

	memset(&(self->s.model_parts[0]), 0, sizeof(model_part_t) * MAX_MODEL_PARTS);
	self->s.num_parts++;
	self->s.model_parts[PART_HEAD].modelindex = gi.modelindex("models/actors/runt/head.mdx");
	skin = gi.skinindex(self->s.model_parts[PART_HEAD].modelindex, head_skin);
	for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
		self->s.model_parts[PART_HEAD].baseskin = self->s.model_parts[PART_HEAD].skinnum[i] = skin;
	gi.GetObjectBounds("models/actors/runt/head.mdx", &self->s.model_parts[PART_HEAD]);

	self->s.num_parts++;
	self->s.model_parts[PART_LEGS].modelindex = gi.modelindex("models/actors/runt/legs.mdx");
	skin = gi.skinindex(self->s.model_parts[PART_LEGS].modelindex, legs_skin);
	for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
		self->s.model_parts[PART_LEGS].baseskin = self->s.model_parts[PART_LEGS].skinnum[i] = skin;
	gi.GetObjectBounds("models/actors/runt/legs.mdx", &self->s.model_parts[PART_LEGS]);

	self->s.num_parts++;
	self->s.model_parts[PART_BODY].modelindex = gi.modelindex("models/actors/runt/body.mdx");
	skin = gi.skinindex(self->s.model_parts[PART_BODY].modelindex, body_skin);
	for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
		self->s.model_parts[PART_BODY].baseskin = self->s.model_parts[PART_BODY].skinnum[i] = skin;
	gi.GetObjectBounds("models/actors/runt/body.mdx", &self->s.model_parts[PART_BODY]);

	if (self->count & 1) // cigar
	{
		self->s.num_parts++;
		self->s.model_parts[PART_CIGAR].modelindex = gi.modelindex("models/actors/runt/cigar.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_CIGAR].baseskin = self->s.model_parts[PART_CIGAR].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/cigar.mdx", &self->s.model_parts[PART_CIGAR]);
	}

	if (self->count & 2) // fedora hat
	{
		self->s.num_parts++;
		self->s.model_parts[PART_HAT].modelindex = gi.modelindex("models/actors/runt/fedora.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_HAT].baseskin = self->s.model_parts[PART_HAT].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/fedora.mdx", &self->s.model_parts[PART_HAT]);
	}
	else if (self->count & 4) // stetson hat
	{
		self->s.num_parts++;
		self->s.model_parts[PART_HAT].modelindex = gi.modelindex("models/actors/runt/stetson.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_HAT].baseskin = self->s.model_parts[PART_HAT].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/stetson.mdx", &self->s.model_parts[PART_HAT]);
	}
	else if (self->count & 8) // cap (hat)
	{
		self->s.num_parts++;
		self->s.model_parts[PART_HAT].modelindex = gi.modelindex("models/actors/runt/cap.mdx");
		for (i = 0; i<MAX_MODELPART_OBJECTS; i++)
			self->s.model_parts[PART_HAT].baseskin = self->s.model_parts[PART_HAT].skinnum[i] = 0;
		gi.GetObjectBounds("models/actors/thug/cap.mdx", &self->s.model_parts[PART_HAT]);
	}


	self->s.renderfx2 |= RF2_DIR_LIGHTS;
	self->s.renderfx |= RF_REFL_MAP;

	self->surfacetype = SURF_GRAVEL;

	gi.linkentity(self);
}